//Selectionlist/Dropdownlist Control, version 0.9, by Andreas Neumann (neumann@karto.baug.ethz.ch)
//initial code was taken from Michel Hirtzler --> pilat.free.fr (thanks!)

//usage-assumptions:
//all variables, functions and ids start with "sL" --> to avoid name-collision
//it is assumed that the global variable document exits (f.e. triggered by "onload" event in the main svg-root-element)
//it is assumed that the svgroot-element contains a "viewBox"-attribute (separated by spaces) - f.e.: - viewBox="0 0 500 400" -
//link this script into the main-document, f.e.: - <script xlink:href="selectionList.js" type="text/ecmascript" /> -
//in the main script add a javascript-array with the array-name "sLselections0", where zero is your link to the control
//f.e.: - var sLselections2 = new Array("Orange1","Orange2","Orange3"); -
//create an empty group in the SVG-document, with the id "sLselectionBox0", where zero is your link to a javascript
//array containing your values, f.e. - <g id="sLselectionBox0"/> - please note that the order within the svg is relevant
//for the rendering order
//finally initialize the creation of the listboxes with the following code:
// - sLcreateSelectionList(0,60,50,250,6,0,"dummy"); -
//usage: sLcreateSelectionList(IndexToStringArray,width,xOffset,yOffset,height(nrOfELements),nrToPreSelect(zero-based!),functionName(to call after selection));
//the function called after selection will get two parameters: the index of the selected Element, an index to the used javascript-array containing the values

//please report bugs and send improvements to neumann@karto.baug.ethz.ch
//if you use this control please link to the original (http://www.carto.net/papers/svg/gui/selectionlist/)
//somewhere in the source-code-comment and give credits, thanks!

var sLactiveSelection = new Array();
var sLselectionVisible = new Array();
var sLfuncName = new Array();
var sLnrHeight = new Array(); //this is to add scrollbar for longer lists
var sLcurLowerIndex = new Array(); //this is to hold current upper index for longer lists
var sLpanStatus = new Array(); //to hold mouse status when moving scrollbar
var sLpanEvtY = new Array(); //to hold previous y-coordinate

//define look and feel here (colors, fonts and stroke-width, cellHeight, etc.)
var sLtextLook = "fill:darkcyan;font-family:Arial,Helvetica,sans-serif;font-size:11px;";
var sLselectBoxfillStroke = "stroke:darkcyan;fill:white;";
var sLscrollBarfillStroke = "stroke:darkcyan;fill:whitesmoke;";
var sLsmallRectLook = "stroke:darkcyan;fill:LightGray;";
var sLhighLightColor = "fill:darkcyan;stroke:none;fill-opacity:0.3;";
var sLhighLightColorUnsel = "fill:white;stroke:none;";
var sLtriangleLook = "stroke:none;fill:darkcyan;";
var sLcellHeight = 16; //outer Height
var sLtriangleFourth = Math.round(sLcellHeight / 4);
var sLtextPaddingHorizontal = 3; //this is relative to the left of the cell
var sLtextPaddingVertical = 12; //this is relative to the top of the cell

//event listener data for Building SelectionList
function sLBSeListener(sLnrSelectList,sLxOffset,sLyOffset,sLwidth) { 
        	this.sLnrSelectList = sLnrSelectList;
        	this.sLxOffset = sLxOffset;
        	this.sLyOffset = sLyOffset;
        	this.sLwidth = sLwidth;
}

//event listener for Building SelectionList
sLBSeListener.prototype.handleEvent = function(evt) {
	if (sLselectionVisible[this.sLnrSelectList]==false) {
		sLshowSelectionList(evt,this.sLnrSelectList,this.sLxOffset,this.sLyOffset,this.sLwidth);
		sLselectionVisible[this.sLnrSelectList]=true;
	}
	else {
		sLhideSelectionList(evt,this.sLnrSelectList);
		sLselectionVisible[this.sLnrSelectList]=false;
	}
}

function sLshowSelectionList(evt,sLnrSelectList,sLxOffset,sLyOffset,sLwidth) {
	sLmyNrSelectionsOrig = eval("sLselections"+sLnrSelectList).length;
	if (sLnrHeight[sLnrSelectList] < sLmyNrSelectionsOrig) {
		sLmyNrSelections=sLnrHeight[sLnrSelectList];
	}
	else {
		sLmyNrSelections=sLmyNrSelectionsOrig;
	}
	//build invisible rect to catch events - currently per default disabled
	//var sLviewBox = new String(document.rootElement.getAttributeNS(null,"viewBox"));
	//var sLviewboxes = sLviewBox.split(' ');
	//sLnode=document.createElementNS(svgNS,"rect");
	//sLnode.setAttributeNS(null,"x",sLviewboxes[0]);
	//sLnode.setAttributeNS(null,"y",sLviewboxes[1]);
	//sLnode.setAttributeNS(null,"width",sLviewboxes[2]);
	//sLnode.setAttributeNS(null,"height",sLviewboxes[3]);
	//sLnode.setAttributeNS(null,"style","fill:white;stroke:none;fill-opacity:0;");
	//sLnode.setAttributeNS(null,"id","sLbgRect"+sLnrSelectList);
	//sLnode.setAttributeNS(null,"onclick","sLbuildSelectionList(evt,"+sLnrSelectList+","+sLxOffset+","+sLyOffset+","+sLwidth+");");
	//document.getElementById("sLselectionGroupRectPlaceholder"+sLnrSelectList).appendChild(sLnode);

	sLselectionHeight=sLcellHeight*sLmyNrSelections;
	sLbelowSelectionObj=document.getElementById("sLbelowSelection"+sLnrSelectList);
	sLbelowSelectionObj.setAttributeNS(null,"height",sLselectionHeight);
	sLbelowSelectionObj.setAttributeNS(null,"visibility","visible");
	//build textElements from array
	sLmySelectionGroup = document.getElementById("sLselectionGroup"+sLnrSelectList);
	for (i=sLcurLowerIndex[sLnrSelectList];i<sLmyNrSelections;i++) {
		//add rectangles to capture events
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal/2);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight*(i+1));
		sLnode.setAttributeNS(null,"width",sLwidth-sLcellHeight-sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLhighLightColorUnsel);
		sLnode.setAttributeNS(null,"id","sLhighlightSelection_"+sLnrSelectList+"_"+i);
		//add event-handler
		sLnode.addEventListener("mouseover", new sLHLeListener(i,sLnrSelectList), false);
		sLnode.addEventListener("mouseout", new sLHLeListener(i,sLnrSelectList), false);
		sLnode.addEventListener("click", new sLHLeListener(i,sLnrSelectList), false);
		sLmySelectionGroup.appendChild(sLnode);
		//add text-elements
		sLnode=document.createElementNS(svgNS,"text");
		sLnode.setAttributeNS(null,"id","sLsubselection"+sLnrSelectList+"_"+i.toString());
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLtextPaddingVertical+sLcellHeight*(i+1));
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLnode.setAttributeNS(null,"style",sLtextLook);
		sLmySelectionsArray = "sLselections"+sLnrSelectList;
		sLselectionText=document.createTextNode(eval(sLmySelectionsArray)[i]);
		sLnode.appendChild(sLselectionText);
		sLmySelectionGroup.appendChild(sLnode);
	}
	//create Scrollbar
	if (sLnrHeight[sLnrSelectList] < sLmyNrSelectionsOrig) {
		//scrollbar
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight);
		sLnode.setAttributeNS(null,"width",sLcellHeight);
		sLnode.setAttributeNS(null,"height",sLselectionHeight);
		sLnode.setAttributeNS(null,"style",sLscrollBarfillStroke);
		sLnode.setAttributeNS(null,"id","sLscrollbarRect_"+sLnrSelectList);
		sLmySelectionGroup.appendChild(sLnode);
		//calculate scrollstep
		var scrollerHeight = (sLnrHeight[sLnrSelectList] / sLmyNrSelectionsOrig) * (sLselectionHeight - 2 * sLcellHeight);
		var sLscrollStep = (sLselectionHeight - 2 * sLcellHeight - scrollerHeight) / (sLmyNrSelectionsOrig - sLnrHeight[sLnrSelectList]);
		//upper rectangle		
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight);
		sLnode.setAttributeNS(null,"width",sLcellHeight);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLsmallRectLook);
		sLnode.setAttributeNS(null,"id","sLscrollUpperRect_"+sLnrSelectList);
		sLnode.addEventListener("click", new sLSCreListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth,"up"), false);
		sLmySelectionGroup.appendChild(sLnode);
		//upper triangle
		sLnode=document.createElementNS(svgNS,"path");
		sLmyPath = "M"+(sLxOffset + sLwidth - 3 * sLtriangleFourth)+" "+(sLyOffset + sLcellHeight + 3 * sLtriangleFourth)+" L"+(sLxOffset + sLwidth - sLtriangleFourth)+" "+(sLyOffset + sLcellHeight + 3 * sLtriangleFourth)+" L"+(sLxOffset+sLwidth - 2 * sLtriangleFourth)+" "+(sLyOffset + sLcellHeight + sLtriangleFourth)+" Z";
		sLnode.setAttributeNS(null,"d",sLmyPath);
		sLnode.setAttributeNS(null,"style",sLtriangleLook);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLnode.setAttributeNS(null,"id","sLscrollUpperTriangle_"+sLnrSelectList);
		sLmySelectionGroup.appendChild(sLnode);
		//lower rectangle		
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLselectionHeight);
		sLnode.setAttributeNS(null,"width",sLcellHeight);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLsmallRectLook);
		sLnode.setAttributeNS(null,"id","sLscrollLowerRect_"+sLnrSelectList);
		sLnode.addEventListener("click", new sLSCreListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth,"down"), false);
		sLmySelectionGroup.appendChild(sLnode);
		//lower triangle
		sLnode=document.createElementNS(svgNS,"path");
		sLmyPath = "M"+(sLxOffset + sLwidth - 3 * sLtriangleFourth)+" "+(sLyOffset + sLselectionHeight + sLtriangleFourth)+" L"+(sLxOffset + sLwidth - sLtriangleFourth)+" "+(sLyOffset + sLselectionHeight + sLtriangleFourth)+" L"+(sLxOffset+sLwidth - 2 * sLtriangleFourth)+" "+(sLyOffset + sLselectionHeight + 3 * sLtriangleFourth)+" Z";
		sLnode.setAttributeNS(null,"d",sLmyPath);
		sLnode.setAttributeNS(null,"style",sLtriangleLook);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLnode.setAttributeNS(null,"id","sLscrollLowerTriangle_"+sLnrSelectList);
		sLmySelectionGroup.appendChild(sLnode);
		//scrollerRect
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight*2);
		sLnode.setAttributeNS(null,"width",sLcellHeight);
		sLnode.setAttributeNS(null,"height",scrollerHeight);
		sLnode.setAttributeNS(null,"style",sLsmallRectLook);
		sLnode.setAttributeNS(null,"id","sLscroller_"+sLnrSelectList);
		sLnode.addEventListener("mousedown", new sLSBeListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth), false);
		sLnode.addEventListener("mouseup", new sLSBeListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth), false);
		sLnode.addEventListener("mousemove", new sLSBeListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth), false);
		sLnode.addEventListener("mouseout", new sLSBeListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth), false);		
		sLmySelectionGroup.appendChild(sLnode);	
	}
}

//event listener data for Highlighter element
function sLHLeListener(sLnr,sLnrSelectList) { 
        	this.sLnr = sLnr;
        	this.sLnrSelectList = sLnrSelectList;
}

//event listener for Highlighter element
sLHLeListener.prototype.handleEvent = function(evt) {
	sLmyEl = evt.target;
	if (evt.type == "mouseover") {
		sLmyEl.setAttributeNS(null,"style",sLhighLightColor);
	}
	if (evt.type == "mouseout") {
		sLmyEl.setAttributeNS(null,"style",sLhighLightColorUnsel);
	}
	if (evt.type == "click") {
		sLactiveSelection[this.sLnrSelectList]=this.sLnr;
		sLhideSelectionList(evt,this.sLnrSelectList);
		sLobject=document.getElementById("sLactualSelectionText"+this.sLnrSelectList);
		sLchild=sLobject.firstChild;
		sLchild.nodeValue=eval("sLselections"+this.sLnrSelectList)[sLactiveSelection[this.sLnrSelectList]];
		sLselectionVisible[this.sLnrSelectList]=false;
		var sLMyFunctionString = sLfuncName[this.sLnrSelectList]+"("+sLactiveSelection[this.sLnrSelectList]+","+this.sLnrSelectList+")"
		setTimeout("eval("+sLMyFunctionString+")",300);
	}
}

function sLhideSelectionList(evt,sLnrSelectList) {
	sLmyNrSelections = eval("sLselections"+sLnrSelectList).length;
	if (sLnrHeight[sLnrSelectList] < sLmyNrSelections) {
		sLmyNrSelections=sLnrHeight[sLnrSelectList];
	}
	else {
		sLmyNrSelections=sLmyNrSelectionsOrig;
	}
	sLobject=document.getElementById("sLbelowSelection"+sLnrSelectList);
	sLobject.setAttributeNS(null,"visibility","hidden");
	sLmySelectionGroup = document.getElementById("sLselectionGroup"+sLnrSelectList);
	for (i=sLcurLowerIndex[sLnrSelectList];i<sLcurLowerIndex[sLnrSelectList]+sLmyNrSelections;i++) {
		sLobject=document.getElementById("sLsubselection"+sLnrSelectList+"_"+i.toString());
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLhighlightSelection_"+sLnrSelectList+"_"+i);
		sLmySelectionGroup.removeChild(sLobject);
	}
	if (sLnrHeight[sLnrSelectList] < sLmyNrSelectionsOrig) {
		//remove scrollbar and related elements
		sLobject=document.getElementById("sLscrollbarRect_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLscrollUpperRect_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLscrollUpperTriangle_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLscrollLowerRect_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLscrollLowerTriangle_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLscroller_"+sLnrSelectList);
		sLmySelectionGroup.removeChild(sLobject);
	}
	//remove background-rect - currently disabled
	//sLnode=document.getElementById("sLbgRect"+sLnrSelectList);
	//document.getElementById("sLselectionGroupRectPlaceholder"+sLnrSelectList).removeChild(sLnode);
	sLcurLowerIndex[sLnrSelectList] = 0;
}

//this is the first function called to initialize
function sLcreateSelectionList(sLnrSelectList,sLwidth,sLxOffset,sLyOffset,sLHeight,nrToSelect,functionName) {
		sLactiveSelection[sLnrSelectList]=0;
		sLfuncName[sLnrSelectList] = functionName;
		sLselectionVisible[sLnrSelectList]=false;
		sLnrHeight[sLnrSelectList] = sLHeight;
		sLcurLowerIndex[sLnrSelectList] = 0; //this value is adapted if the user moves scrollbar
		sLmySelectionBox = document.getElementById("sLselectionBox"+sLnrSelectList);
		//group node to hold dummy rectangle to catch mouse-events to prevent routing events to other elements
		//and to allow closing of the list after losing focus
		sLnode=document.createElementNS(svgNS,"g");
		sLnode.setAttributeNS(null,"id","sLselectionGroupRectPlaceholder"+sLnrSelectList);
		sLmySelectionBox.appendChild(sLnode);
		//initial Rect, visible at the beginning
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset);
		sLnode.setAttributeNS(null,"y",sLyOffset);
		sLnode.setAttributeNS(null,"width",sLwidth);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLselectBoxfillStroke);
		sLnode.addEventListener("click", new sLBSeListener(sLnrSelectList,sLxOffset,sLyOffset,sLwidth), false);
		sLmySelectionBox.appendChild(sLnode);
		//initial text
		sLnode=document.createElementNS(svgNS,"text");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLtextPaddingVertical);
		sLnode.setAttributeNS(null,"style",sLtextLook);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLselectionText=document.createTextNode(eval("sLselections"+sLnrSelectList)[nrToSelect]);
		sLnode.appendChild(sLselectionText);
		sLnode.setAttributeNS(null,"id","sLactualSelectionText"+sLnrSelectList);
		sLmySelectionBox.appendChild(sLnode);
		//small Rectangle to the right, onclick unfolds the selectionList
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"y",sLyOffset);
		sLnode.setAttributeNS(null,"width",sLcellHeight);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLsmallRectLook);
		sLnode.addEventListener("click", new sLBSeListener(sLnrSelectList,sLxOffset,sLyOffset,sLwidth), false);
		sLmySelectionBox.appendChild(sLnode);
		//triangle
		sLnode=document.createElementNS(svgNS,"path");
		sLmyPath = "M"+(sLxOffset + sLwidth - 3 * sLtriangleFourth)+" "+(sLyOffset + sLtriangleFourth)+" L"+(sLxOffset + sLwidth - sLtriangleFourth)+" "+(sLyOffset + sLtriangleFourth)+" L"+(sLxOffset+sLwidth - 2 * sLtriangleFourth)+" "+(sLyOffset + 3 * sLtriangleFourth)+" Z";
		sLnode.setAttributeNS(null,"d",sLmyPath);
		sLnode.setAttributeNS(null,"style",sLtriangleLook);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLmySelectionBox.appendChild(sLnode);
		//rectangle below unfolded selectBox
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight);
		sLnode.setAttributeNS(null,"width",sLwidth-sLcellHeight);
		sLnode.setAttributeNS(null,"height",0);
		sLnode.setAttributeNS(null,"style",sLselectBoxfillStroke+"visibility:hidden;");
		sLnode.setAttributeNS(null,"id","sLbelowSelection"+sLnrSelectList);
		sLmySelectionBox.appendChild(sLnode);
		//group node to hold dynamic text elements and highLight-Rects
		sLnode=document.createElementNS(svgNS,"g");
		sLnode.setAttributeNS(null,"id","sLselectionGroup"+sLnrSelectList);
		sLmySelectionBox.appendChild(sLnode);
}

//event listener data for Scrollbar element
function sLSBeListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth) { 
        	this.sLnrSelectList = sLnrSelectList;
        	this.sLxOffset = sLxOffset;
        	this.sLyOffset = sLyOffset;
        	this.sLscrollStep = sLscrollStep;
        	this.sLwidth = sLwidth;
}

//event listener for Scrollbar element
sLSBeListener.prototype.handleEvent = function(evt) {
	var sLscroller = document.getElementById("sLscroller_"+this.sLnrSelectList);
	if (evt.type == "mousedown") {
		sLpanStatus[this.sLnrSelectList] = 1;
		sLpanEvtY[this.sLnrSelectList] = parseFloat(evt.clientY);
		sLscroller.setAttributeNS(null,"style",sLtriangleLook);
	}
	if (evt.type == "mouseup" || evt.type == "mouseout") {
		sLpanStatus[this.sLnrSelectList] = 0;
		sLscroller.setAttributeNS(null,"style",sLsmallRectLook);
		sLscroller.setAttributeNS(null,"y",this.sLyOffset+sLcellHeight*2+this.sLscrollStep*sLcurLowerIndex[this.sLnrSelectList]);
	}
	if (evt.type == "mousemove") {
		if (sLpanStatus[this.sLnrSelectList] == 1) {
			var sLscrollBar = document.getElementById("sLscrollbarRect_"+this.sLnrSelectList);
			var sLpanNewEvtY = parseFloat(evt.clientY);
			var newY = parseFloat(sLscroller.getAttributeNS(null,"y")) + sLpanNewEvtY - sLpanEvtY[this.sLnrSelectList];
			if ((newY >= this.sLyOffset + sLcellHeight * 2) && (newY <= this.sLyOffset + parseFloat(sLscrollBar.getAttributeNS(null,"height")) - parseFloat(sLscroller.getAttributeNS(null,"height")))) {
				sLscroller.setAttributeNS(null,"y",newY);
				if ((sLpanNewEvtY > sLpanEvtY[this.sLnrSelectList]) && (newY - (this.sLyOffset+sLcellHeight*2+this.sLscrollStep*sLcurLowerIndex[this.sLnrSelectList])) > (this.sLscrollStep - this.sLscrollStep*0.999)) {
					sLscrollIt(evt,this.sLnrSelectList,'down',this.sLscrollStep,this.sLxOffset,this.sLyOffset,this.sLwidth,"no");	
				}
				if ((sLpanNewEvtY < sLpanEvtY[this.sLnrSelectList]) && (newY - (this.sLyOffset+sLcellHeight*2+this.sLscrollStep*sLcurLowerIndex[this.sLnrSelectList])) < (this.sLscrollStep - this.sLscrollStep*0.999)) {
					sLscrollIt(evt,this.sLnrSelectList,'up',this.sLscrollStep,this.sLxOffset,this.sLyOffset,this.sLwidth,"no");	
				}
			}
			sLpanEvtY[this.sLnrSelectList] = sLpanNewEvtY;
		}
	}
}

//event listener data for scroll element
function sLSCreListener(sLnrSelectList,sLxOffset,sLyOffset,sLscrollStep,sLwidth,direction) { 
        	this.sLnrSelectList = sLnrSelectList;
        	this.sLxOffset = sLxOffset;
        	this.sLyOffset = sLyOffset;
        	this.sLscrollStep = sLscrollStep;
        	this.sLwidth = sLwidth;
        	this.direction = direction;
}

//event listener for scroll element
sLSCreListener.prototype.handleEvent = function(evt) {
		sLscrollIt(evt,this.sLnrSelectList,this.direction,this.sLscrollStep,this.sLxOffset,this.sLyOffset,this.sLwidth,"yes");	
}

function sLscrollIt(evt,sLnrSelectList,sLdirection,sLscrollStep,sLxOffset,sLyOffset,sLwidth,sLstepBool) {
	sLmyNrSelections = eval("sLselections"+sLnrSelectList).length;
	sLobject=document.getElementById("sLscroller_"+sLnrSelectList);
	sLmySelectionGroup = document.getElementById("sLselectionGroup"+sLnrSelectList);
	if ((sLcurLowerIndex[sLnrSelectList] > 0) && (sLdirection == "up")) {
		//decrement current index
		sLcurLowerIndex[sLnrSelectList] = sLcurLowerIndex[sLnrSelectList] - 1;
		sLscrollStep = sLscrollStep * -1;
		if (sLstepBool == "yes") {
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))+sLscrollStep);
		}
		//add most upper rect element
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal/2);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight);
		sLnode.setAttributeNS(null,"width",sLwidth-sLcellHeight-sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLhighLightColorUnsel);
		sLnode.setAttributeNS(null,"id","sLhighlightSelection_"+sLnrSelectList+"_"+sLcurLowerIndex[sLnrSelectList]);
		//add event-handler
		sLnode.addEventListener("mouseover", new sLHLeListener(sLcurLowerIndex[sLnrSelectList],sLnrSelectList), false);
		sLnode.addEventListener("mouseout", new sLHLeListener(sLcurLowerIndex[sLnrSelectList],sLnrSelectList), false);
		sLnode.addEventListener("click", new sLHLeListener(sLcurLowerIndex[sLnrSelectList],sLnrSelectList), false);
		sLmySelectionGroup.appendChild(sLnode);
		//add text-node
		sLnode=document.createElementNS(svgNS,"text");
		sLnode.setAttributeNS(null,"id","sLsubselection"+sLnrSelectList+"_"+sLcurLowerIndex[sLnrSelectList]);
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLtextPaddingVertical+sLcellHeight);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLnode.setAttributeNS(null,"style",sLtextLook);
		sLmySelectionsArray = "sLselections"+sLnrSelectList;
		sLselectionText=document.createTextNode(eval(sLmySelectionsArray)[sLcurLowerIndex[sLnrSelectList]]);
		sLnode.appendChild(sLselectionText);
		sLmySelectionGroup.appendChild(sLnode);
		for (i=sLcurLowerIndex[sLnrSelectList]+1;i<sLcurLowerIndex[sLnrSelectList]+sLnrHeight[sLnrSelectList];i++) {
			sLobject=document.getElementById("sLsubselection"+sLnrSelectList+"_"+i);
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))+sLcellHeight);
			sLobject=document.getElementById("sLhighlightSelection_"+sLnrSelectList+"_"+i);
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))+sLcellHeight);
		}
		//remove most lower element 
		sLobject=document.getElementById("sLsubselection"+sLnrSelectList+"_"+i);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLhighlightSelection_"+sLnrSelectList+"_"+i);
		sLmySelectionGroup.removeChild(sLobject);
	}
	else if ((sLcurLowerIndex[sLnrSelectList] < sLmyNrSelections - sLnrHeight[sLnrSelectList]) && (sLdirection == "down")) {
		if (sLstepBool == "yes") {
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))+sLscrollStep);
		}
		//remove most upper element 
		sLobject=document.getElementById("sLsubselection"+sLnrSelectList+"_"+sLcurLowerIndex[sLnrSelectList]);
		sLmySelectionGroup.removeChild(sLobject);
		sLobject=document.getElementById("sLhighlightSelection_"+sLnrSelectList+"_"+sLcurLowerIndex[sLnrSelectList]);
		sLmySelectionGroup.removeChild(sLobject);
		for (i=sLcurLowerIndex[sLnrSelectList]+1;i<sLcurLowerIndex[sLnrSelectList]+sLnrHeight[sLnrSelectList];i++) {
			sLobject=document.getElementById("sLsubselection"+sLnrSelectList+"_"+i);
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))-sLcellHeight);
			sLobject=document.getElementById("sLhighlightSelection_"+sLnrSelectList+"_"+i);
			sLobject.setAttributeNS(null,"y",parseFloat(sLobject.getAttributeNS(null,"y"))-sLcellHeight);
		}
		//add most lower element
		sLnode=document.createElementNS(svgNS,"rect");
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal/2);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLcellHeight*sLnrHeight[sLnrSelectList]);
		sLnode.setAttributeNS(null,"width",sLwidth-sLcellHeight-sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"height",sLcellHeight);
		sLnode.setAttributeNS(null,"style",sLhighLightColorUnsel);
		sLnode.setAttributeNS(null,"id","sLhighlightSelection_"+sLnrSelectList+"_"+i);
		sLnode.addEventListener("mouseover", new sLHLeListener(i,sLnrSelectList), false);
		sLnode.addEventListener("mouseout", new sLHLeListener(i,sLnrSelectList), false);
		sLnode.addEventListener("click", new sLHLeListener(i,sLnrSelectList), false);
		sLmySelectionGroup.appendChild(sLnode);
		//add event-handler
		sLnode=document.createElementNS(svgNS,"text");
		sLnode.setAttributeNS(null,"id","sLsubselection"+sLnrSelectList+"_"+i.toString());
		sLnode.setAttributeNS(null,"x",sLxOffset+sLtextPaddingHorizontal);
		sLnode.setAttributeNS(null,"y",sLyOffset+sLtextPaddingVertical+sLcellHeight*sLnrHeight[sLnrSelectList]);
		sLnode.setAttributeNS(null,"pointer-events","none");
		sLnode.setAttributeNS(null,"style",sLtextLook);
		sLmySelectionsArray = "sLselections"+sLnrSelectList;
		sLselectionText=document.createTextNode(eval(sLmySelectionsArray)[i]);
		sLnode.appendChild(sLselectionText);
		sLmySelectionGroup.appendChild(sLnode);
		//increment current index
		sLcurLowerIndex[sLnrSelectList] = sLcurLowerIndex[sLnrSelectList] + 1;
	}
}
