/******************************************************************************************/
//global variables
/******************************************************************************************/
var svgroot;
var svgNS = "http://www.w3.org/2000/svg";
var xlinkNS = "http://www.w3.org/1999/xlink";
var atNS = "http://www.geo.unizh.ch/corinna/";
var attribNS= "http://www.carto.net/attrib/";
var myMapApp = new mapApp();
var myMainMap;
var myThematicMap;
var myRefMapDragger;
var myZoomSlider;
var zoomValTxt;
//globals for changeable selectionLists
var selQuartier;
var selZeitraum;
var selRichtung;
var selBevgruppen;
var selGruppDetail;
var selGruppDat,selGruppDat0,selGruppDat1,selGruppDat2,selGruppDat3;
var selGruppDatShadow,selGruppDat0Shadow, selGruppDat1Shadow,selGruppDat2Shadow,selGruppDat3Shadow;

var thematicMaps = new Array();

var selQuartierDat;
var sLselQuartDatShadow;
var sLselQuartNr;
var selBevgruppenDat;
var selZeitraumDat;
var selZeitraumDatShadow;
var selKlasseDatShadow;
var selRichtungDat;
var selRichtungDatShadow;
//erste wert in der liste 'sLselections0' (Quartiere)
var quartObj;
var quartColourSel= 'rgb(255,255,183)';	//yellow
var quartColourNonSel= 'rgb(153,153,153)'; //grey

var sliderHue;
//var sliderVal;
var myColorPicker;

/******************************************************************************************/
//initializing values
/******************************************************************************************/
function init(evt){
	svgroot = document.rootElement;
	myMapApp.resetFactors();
	var dynamicLayers = new Array(); //fuer dynamisches nachladen von Datenbanken, nicht in Verwendung
	//mapName,dynamicLayers,origWidth,minZoom,maxZoom,zoomFact
	//change origWidth if you adapt to other regions
	myMainMap = new map("mainMap",dynamicLayers,88406,100,1000,0.5);
	//slider properties: x1,y1,value1,x2,y2,value2,startValue,group in which to build the slider,color of slider
	//width of slider of sliderbar,width of invisible slider bar,width of visible slider
	//function to call on mouseup/move, sendVal on mouse move (true|false)
	myZoomSlider = new slider(1058.3,423,myMainMap.origWidth / 10,968.3,423,myMainMap.origWidth,myMainMap.origWidth,"mapZoomSlider","rgb(153,153,153)",13.5,14,"sliderSymbol","myRefMapDragger.resizeDragger",true);
	myRefMapDragger = new dragObj("dragRectForRefMap","referenceMap","myDragCross",10000);		//set constraints to draggable rect in reference map
	//mapsheetFrame = document.getElementById("mapsheetFrame"); 	//overviewObjects
	//usage: createSelectionList(IndexToStringArray,width,xOffset,yOffset,height(nrOfELements),nrToPreSelect(zero-based!),functionName) --> create an empty group width Id 'selection+indexNr'*/	
	selQuartierDat = new Array("Zuerich","Affoltern","Albisrieden","Altstetten","Alt-Wiedikon","City","Enge","Escher Wyss","Fluntern","Friesenberg","Gewerbeschule","Hard","Hirslanden","Hirzenbach","Hochschulen","Hottingen","Hoengg","Langstrasse","Leimbach","Lindenhof","Muehlebach","Oberstrass","Oerlikon","Rathaus","Saatlen","Schwamendingen-M","Seebach","Seefeld","Sihlfeld","Unterstrass","Weinegg","Werd","Wipkingen","Witikon","Wollishofen");
	sLselQuartDatShadow = new Array("100","111000","91000","92000","31000","14000","24000","52000","71000","33000","51000","44000","73000","123000","12000","72000","101000","42000","23000","13000","82000","63000","115000","11000","121000","122000","119000","81000","34000","61000","83000","41000","102000","74000","21000");
	sLselQuartNr= new Array(0,32,42,41,53,54,45,53,36,32,62,51,45,41,64,45,34,62,32,55,55,46,53,55,31,51,41,65,52,54,44,63,53,35,43);
	
	selZeitraumDat = new Array('1991 bis 1996','1997 bis 2002','1991 bis 2002');//Zeitraum
	selZeitraumDatShadow = new Array('PE','PZ','tot');
	
	selRichtungDat = new Array('Wegzug','Zuzug','Total','Saldi');	//Richtung
	selRichtungDatShadow = new Array('weg','ein','total','saldo');
	
	selBevgruppenDat = new Array('Familienstand','Nationalitaet','Alter','Fam./Einzelpers.','Total');	//	Bevoelkerungsgruppen
	
	//sub lists for bev.gruppen-list
	selGruppDat0 = new Array('ledig','verheiratet','verwitwet','geschieden');//Familienstand	
	selGruppDat0Shadow= new Array('le','vh','vw','gs');	
	
	selGruppDat1 = new Array('Schweizer','Auslaender');			//nationaliaet
	selGruppDat1Shadow= new Array('CH','A');
										//alter
	selGruppDat2 = new Array('0 bis 6 Jahre','7 bis 15 Jahre','16 bis 19 Jahre','20 bis 24 Jahre','25 bis 44 Jahre','45 bis 64 Jahre','65 bis 79 Jahre','>80 Jahre');
	selGruppDat2Shadow= new Array('AGRP00','AGRP07','AGRP16','AGRP20','AGRP25','AGRP45','AGRP65','AGRP80');
	
	selGruppDat3 = new Array('Familienpersonen','Einzelpersonen'); 		//Fam./Einzelpers.
	selGruppDat3Shadow= new Array('F','E');
	
	selGruppDatShadow  = selGruppDat0Shadow;	//setzen der default liste 
	selGruppDat=selGruppDat0;			
	
	//lists to change classification
	var selKlasseDat = new Array ('Gleiche Intervalle','Quantile');		//klassifikationsmethoden
	selKlasseDatShadow = new Array ('equalDist','quantile');
	var selAnzahlDat = new Array('2','3','4','5','6','7','8','9');		//Anzahl der Klassen
	
	//initialize selectionLists
	//groupName in SVG,arrayName,width,xOffset,yOffset,nr of Elements in elementHeight,preSelection,functionName to call after selection
	selQuartier = new selectionList("selQuartier",selQuartierDat,155,230,130,6,0,"changeQuartByList");	//Quartier
	selZeitraum = new selectionList("selZeitraum",selZeitraumDat,115,478,130,3,2,"selectTimeframe");	//Zeitraum
	selRichtung = new selectionList("selRichtung",selRichtungDat,73,478,190,4,0,"selectDirection");		//Richtung
	selBevgruppen = new selectionList("selBevgruppen",selBevgruppenDat,135,679,130,6,4,"selectBevGrupp");	//Bev.gruppen
	selGruppDetail = new selectionList("selGruppDetail",selGruppDat,135,679,190,5,0,"selectDetail");	//detailiert zu Bev.gruppen
	selKlasse = new selectionList("selKlasse",selKlasseDat,145,890,130,2,0,"selectClass");			//Art Klassierung
	selAnzahl = new selectionList("selAnzahl",selAnzahlDat,33,890,190,6,4,"changeClassNr");			//Anzahl Klassen	
	
	quartObj = document.getElementById('quartier_'+eval('sLselQuartDatShadow')[0]);		//einfaerben des default-quartiers
	quartObj.setAttributeNS(null,'style','fill:rgb(255,255,183)');
	//slider properties: x1,y1,value1,x2,y2,value2,startValue,group in which to build the slider,color of slider 
	//width of slider of sliderbar,width of invisible slider bar,width of visible slider 
	//function to call on mouseup/move, sendVal on mouse move (true|false)
	sliderHue = new slider(590,358,0,705,358,360,30,"sliderHue","url(#hueGradient)",10,15,"sliderSymbolDarkcyan","myColorPicker.getHSV",true);
	sliderVal = new slider(590,380,0,705,380,100,100,"sliderVal","url(#valGradient)",10,15,"sliderSymbolDarkcyan","myColorPicker.getHSV",true);
	myColorPicker = new colorPicker;
	//mapId,groupNameForData,quartierId,varToMap,direction,timeframe,classMethod (quantile|equalDist), nrClasses, hue, val, prefDat in XML, prefGeom in SVG, legendGroup in SVG
	myQuadrat = new thematicMap(myMainMap.mapName,"quaddat_data",100,"total","weg","tot","equalDist",6,30,1,"quaddat_","quadrat_","legendDiagr");	 //haupt-themat.karte
	thematicMaps["quaddat"] = myQuadrat;
	myQuadrat.getData();
	myThematicMap = new thematicMap(myMainMap.mapName,"kartdat_data",100,"total","weg","tot","equalDist",6,30,1,"kartdat_","units_","legendMap");	//diagramm-themat.karte
	thematicMaps["kartdat"] = myThematicMap;	//myThematicMap ... Instanz , thematicMap ... objekt/klasse
	myThematicMap.getData();	
	
	
}
/******************************************************************************************/
//CHANGES QUARTIER VIA LIST
/******************************************************************************************/
function changeQuartByList(indexNr,value){	//auswahl via liste
	myThematicMap.quartierId = parseInt(sLselQuartDatShadow[indexNr]);
	myQuadrat.quartierId = parseInt(sLselQuartDatShadow[indexNr]);
	myThematicMap.getData();
	myQuadrat.getData();
	quartObj.setAttributeNS(null,'style','fill:'+quartColourNonSel);
	var quartName = 'quartier_'+eval('sLselQuartDatShadow')[indexNr];
	quartObj = document.getElementById(quartName);
	quartObj.setAttributeNS(null,'style','fill:'+quartColourSel);	
	quartNr= document.getElementById("quadrat_"+sLselQuartNr[indexNr])
	var xOff= quartNr.getAttributeNS(null,"x");
	var yOff= quartNr.getAttributeNS(null,"y");
	document.getElementById("quadrat_dummy").setAttributeNS(null,"x",xOff);
	document.getElementById("quadrat_dummy").setAttributeNS(null,"y",yOff);
	
	document.getElementById("sum1").firstChild.nodeValue = selQuartierDat[indexNr]+", ";
}
/******************************************************************************************/
//CHANGES QUARTIE VIA MAP
/******************************************************************************************/
function selectQuartier(){	// via map
	var el = evt.target;
	var elId = el.getAttributeNS(null,'id');
	var elId = elId.replace(/quartier_/,"");;
	var j;
	for(var i=0;i<sLselQuartDatShadow.length;i++){	//sLselQuartDatShadow: liste mit ids von bez., gem.
		if(sLselQuartDatShadow[i]==elId){
			j=i;
		}
	}
	selQuartier.selectElementByPosition(j,true);	//funktion changeQuartByList(indexNr,value) wird anschliessend aufgerufen
}
/******************************************************************************************/
//CHANGE TIME FRAME
/******************************************************************************************/
function selectTimeframe(indexNr,value){
	myThematicMap.timeframe= selZeitraumDatShadow[indexNr];
	myThematicMap.readData();
	myQuadrat.timeframe= selZeitraumDatShadow[indexNr];
	myQuadrat.readData();
	document.getElementById("sum2").firstChild.nodeValue = selZeitraumDat[indexNr]+", ";
}
/******************************************************************************************/
//CHANGE DIRECTION OF MOVEMENTS (WEG, EIN,...)
/******************************************************************************************/
function selectDirection(indexNr,value){
	myThematicMap.direction= selRichtungDatShadow[indexNr];
	myThematicMap.readData();
	myQuadrat.direction= selRichtungDatShadow[indexNr];
	myQuadrat.readData();
	document.getElementById("sum3").firstChild.nodeValue = "Richtung "+selRichtungDat[indexNr]+", ";
}
/******************************************************************************************/
//SELECT DIFFERENT BEV.GRUPPE
/******************************************************************************************/
function selectBevGrupp(indexNr,value){
	if(indexNr!=4){
		document.getElementById('selGruppDetail').setAttributeNS(null,'visibility','visible');		
		selGruppDat = eval('selGruppDat'+indexNr);
		selGruppDatShadow = eval('selGruppDat'+indexNr+'Shadow');
		selGruppDetail.elementsArray = selGruppDat;
		selGruppDetail.activeSelection = 0;
		selGruppDetail.createSelectionList();
		myThematicMap.varToMap= selGruppDatShadow[0];
		myThematicMap.readData();
		myQuadrat.varToMap= selGruppDatShadow[0];
		myQuadrat.readData();
		document.getElementById("sum5").firstChild.nodeValue = selGruppDat[0];
	}else{
		document.getElementById('selGruppDetail').setAttributeNS(null,'visibility','hidden');
		document.getElementById("sum5").firstChild.nodeValue = " ";
	}
	document.getElementById("sum4").firstChild.nodeValue = selBevgruppenDat[indexNr]+" ";
	
}
/******************************************************************************************/
//SELECT ... UNTERGRUPPE
/******************************************************************************************/
function selectDetail(indexNr,value){
	myThematicMap.varToMap= selGruppDatShadow[indexNr];
	myThematicMap.readData();
	myQuadrat.varToMap= selGruppDatShadow[indexNr];
	myQuadrat.readData();
	document.getElementById("sum5").firstChild.nodeValue = selGruppDat[indexNr];
}

/******************************************************************************************/
//CHANGES NR. OF CLASSES AND REDRAWS THEMATIC MAP
/******************************************************************************************/
function changeClassNr(indexNr,value){	
	myThematicMap.nrClasses = parseInt(value);
	myThematicMap.drawMap();
	myQuadrat.nrClasses = parseInt(value);
	myQuadrat.drawMap();	
}
/******************************************************************************************/
//CHANGES TYPE OF CLASSIFICATION
/******************************************************************************************/
function selectClass(indexNr,value){	
	myThematicMap.classMethod = selKlasseDatShadow[indexNr]
	myThematicMap.drawMap();
	myQuadrat.classMethod = selKlasseDatShadow[indexNr]
	myQuadrat.drawMap();
}
/******************************************************************************************/
//FUNCTIONS FOR SLIDER, COLOUR PICKER,
/******************************************************************************************/
function colorPicker() {
	this.hue = Math.round(sliderHue.value);
	this.val = Math.round(sliderVal.value) / 100;
	this.rgbArr = hsv2rgb(this.hue,1,this.val); //
	this.colorRect = document.getElementById("colorRect");
	this.colorTextRGB = document.getElementById("colorTextRGB");
	this.colorTextHSV = document.getElementById("colorTextHSV");
	this.valEndGradient = document.getElementById("valStopEndColor");
	this.valStartGradient = document.getElementById("valStopStartColor");
}
colorPicker.prototype.getHSV = function(valType,groupId,value) {
	//alert(valType);
	switch(groupId) {
		case "sliderHue":
			this.hue = Math.round(value);
			break;
		case "sliderSat":
			this.sat = Math.round(value) / 100;
			break;
		case "sliderVal":
			this.val = Math.round(value) / 100;
			break;
	}
	this.rgbArr = hsv2rgb(this.hue,1,this.val);
	rgbValEnd = hsv2rgb(this.hue,1,1);
	rgbValStart = hsv2rgb(this.hue,1,0);			
	this.colorRect.setAttributeNS(null,"fill","rgb("+this.rgbArr["red"]+","+this.rgbArr["green"]+","+this.rgbArr["blue"]+")");
	this.colorTextRGB.firstChild.nodeValue = "RGB: "+this.rgbArr["red"]+","+this.rgbArr["green"]+","+this.rgbArr["blue"];
	this.colorTextHSV.firstChild.nodeValue = "HSV: "+this.hue+",100,"+Math.round(this.val*100);		
	this.valStartGradient.setAttributeNS(null,"style","stop-color:rgb("+rgbValStart["red"]+","+rgbValStart["green"]+","+rgbValStart["blue"]+")");
	this.valEndGradient.setAttributeNS(null,"style","stop-color:rgb("+rgbValEnd["red"]+","+rgbValEnd["green"]+","+rgbValEnd["blue"]+")");			
	if(valType=="release"){
		myThematicMap.hue = this.hue;
		myThematicMap.val = this.val;
		myThematicMap.drawMap();
		myQuadrat.hue = this.hue;
		myQuadrat.val = this.val;
		myQuadrat.drawMap();
	}
}
/******************************************************************************************/
//DUMMY
/******************************************************************************************/
function dummy(indexNr,value) {
	alert(value);
}
/******************************************************************************************/
//IMPRESSUM
/******************************************************************************************/
function impressum(val){
	var newState;
	if(val=="hide"){
		newState="hidden";
	}
	if(val=="show"){
		newState="visible";
	}
	document.getElementById("impress").setAttributeNS(null,"visibility",newState);
}
/******************************************************************************************/
//SHOW DATA OF MAIN MAP		
/******************************************************************************************/
function showData(evt, theme) {
	var el = evt.target;
	var elName;
	var elClass;
	var elValue;
	var elSozi;
	var displayTxt1,displayTxt2,displayTxt3,displayTxt4;
	var legEl;
	
	if(theme=='unit'){
		elName = el.getAttributeNS(attribNS,'NAMEN');	
		elClass = el.getAttributeNS(attribNS,"Class");
		elValue = Math.round(el.getAttributeNS(attribNS,"Value")*10000)/100;
		elSozi = el.getAttributeNS(attribNS,'E_QUADRAT');	//replace(/CheckBox/,"");
		elSozi = 'Lebensstil '+elSozi.substr(0,1)+' und Status '+elSozi.substr(1,1);
		if(elClass=="-") {
			
			elClass="-";
		}
		if(elClass!="-"){
		                // legendMap_class_ will be created on-demand in thematicMap.es
			legEl = document.getElementById("legendMap_class_"+new String (elClass-1));
		}
		elName = elName;	//"Einheit: " +
		elClass = "Klasse: "+elClass;
		elValue = "Wert: "+elValue+"%";
		 
		
		displayTxt1 = document.getElementById("dataDisplayMap1");	
		displayTxt2 = document.getElementById("dataDisplayMap2");	
		displayTxt3 = document.getElementById("dataDisplayMap3");	
		displayTxt4 = document.getElementById("dataDisplayMap4");
	}
	if(theme=='kanton'){
		elName = el.getAttributeNS(attribNS,'NAMEN');
		//elName = "Kanton: "+elName;
		elClass = " ";
		elValue = " ";
		elSozi = " ";
		displayTxt1 = document.getElementById("dataDisplayMap1");
		displayTxt2 = document.getElementById("dataDisplayMap2");	
		displayTxt3 = document.getElementById("dataDisplayMap3");	
		displayTxt4 = document.getElementById("dataDisplayMap4");
	}
	if(theme=='see'){
		elName = el.getAttributeNS(attribNS,'NAME');
		elName = elName;	//"See: "+
		elClass = " ";
		elValue = " ";
		elSozi = " ";
		displayTxt1 = document.getElementById("dataDisplayMap1");
		displayTxt2 = document.getElementById("dataDisplayMap2");	
		displayTxt3 = document.getElementById("dataDisplayMap3");	
		displayTxt4 = document.getElementById("dataDisplayMap4");
	}
	if(theme=='quadrat'){
		elName = el.getAttributeNS(null,'id');
		elClass = el.getAttributeNS(attribNS,"Class");
		if(elClass!="-"){
		                // legendDiagr_class_ will be created on-demand in thematicMap.es
			legEl = document.getElementById("legendDiagr_class_"+new String (elClass-1));
		}
		elName = 'Lebensstil '+elName.substr(8,1)+' und Status '+elName.substr(9,1);
		elClass = "Klasse: "+elClass;
		if(elClass=="-") {elName="Keine Daten.";}
		elValue = " ";
		elSozi = " ";
		//elSozi = el.getAttributeNS(attribNS,'E_QUADRAT');
		displayTxt1 = document.getElementById("dataDisplayDiagr1");
		displayTxt2 = document.getElementById("dataDisplayDiagr2");
		displayTxt3 = document.getElementById("dataDisplayMap3");	
		displayTxt4 = document.getElementById("dataDisplayMap4");
	}
	if(theme=='quart'){
		elName = el.getAttributeNS(attribNS,'NAMEN');		//elName = "Quartier: "+elName;
		elClass = " ";		
		elValue = " ";
		elSozi = " ";
		displayTxt1 = document.getElementById("dataDisplayQuart");
		displayTxt2 = document.getElementById("dataDisplayDiagr2");
		displayTxt3 = document.getElementById("dataDisplayMap3");	
		displayTxt4 = document.getElementById("dataDisplayMap4");
	}
	if (evt.type == "mouseover"){
		displayTxt1.firstChild.nodeValue = elName;
		displayTxt2.firstChild.nodeValue = elClass;
		displayTxt3.firstChild.nodeValue = elValue;
		displayTxt4.firstChild.nodeValue = elSozi;
		if(legEl!=null){
			legEl.setAttributeNS(null,"stroke-width",2.5);
		}
	}
	if (evt.type == "mouseout") {
		displayTxt1.firstChild.nodeValue = " ";
		displayTxt2.firstChild.nodeValue = " ";	
		displayTxt3.firstChild.nodeValue = " ";
		displayTxt4.firstChild.nodeValue = " ";
		if(legEl!=null){
			legEl.setAttributeNS(null,"stroke-width",1);
		}
	}
}

/******************************************************************************************/
//change array of sLselections4 in order to choice made in sLselections3
/******************************************************************************************/
function selectGroups(indexNr,listNr) {
	//alert('you clicked Nr. '+(indexNr)+', value: '+eval('sLselections'+listNr)[indexNr]);
	//sLselections4= eval('sLsel'+indexNr);
	//sLcreateSelectionList(4,150,270,690,4,0,' ');	
}


/******************************************************************************************/
//show coordintates 
/******************************************************************************************/
function showCoords(evt) {
	var mapCoords = myMainMap.calcCoord(evt.clientX,evt.clientY);
	document.getElementById("coordX").firstChild.nodeValue = "E: "+ mapCoords["x"].toFixed(myMainMap.nrDigits) + myMainMap.units;
	document.getElementById("coordY").firstChild.nodeValue = "N: "+ (mapCoords["y"] * -1).toFixed(myMainMap.nrDigits) + myMainMap.units;
	if (evt.type == "mouseout") {
		document.getElementById("coordX").firstChild.nodeValue = " ";
		document.getElementById("coordY").firstChild.nodeValue = " ";
	}	
}

/******************************************************************************************/
//show help texts 
/******************************************************************************************/
function showHelp(evt, text)  {
	if (evt.type == "mouseover"){	
		document.getElementById("Help_Text").firstChild.nodeValue = 'Statusbar: '+text; 
	}
	if (evt.type == "mouseout") {
		document.getElementById("Help_Text").firstChild.nodeValue ='Statusbar: '; 
	}		
}

/******************************************************************************************/
//TO HIDE WINDOWS
/******************************************************************************************/
function handleWindow(evt,winName) {	
	var txt = winName+'Window';	// window name
	var win = document.getElementById(txt);
	var currentState = win.getAttributeNS(null,"visibility");
	if (currentState == "hidden") {
		newState = "visible";
	} else {
		newState = "hidden";
	}
	win.setAttributeNS(null,"visibility", newState);
}
