//holds data on map
function map(mapName,dynamicLayers,origWidth,minZoom,maxZoom,zoomFact) {
	this.mapName = mapName;
	var mapSVG = document.getElementById(this.mapName);
	this.dynamicLayers = dynamicLayers;
	this.nrLayerToLoad = 0;
	this.origWidth = origWidth;
	this.minZoom = minZoom;
	this.maxZoom = maxZoom;
	this.zoomFact = zoomFact;
	this.pixXOffset = parseFloat(mapSVG.getAttributeNS(null,"x"));
	this.pixYOffset = parseFloat(mapSVG.getAttributeNS(null,"y"));
	viewBoxArray = mapSVG.getAttributeNS(null,"viewBox").split(" ");
	this.curxOrig = parseFloat(viewBoxArray[0]);
	this.curyOrig = parseFloat(viewBoxArray[1]);
	this.curWidth = parseFloat(viewBoxArray[2]);
	this.curHeight = parseFloat(viewBoxArray[3]);
	this.pixWidth = parseFloat(mapSVG.getAttributeNS(null,"width"));
	this.pixHeight = parseFloat(mapSVG.getAttributeNS(null,"height"));
	this.pixSize = this.curWidth / this.pixWidth;
	this.zoomVal = this.origWidth / this.curWidth * 100;
	this.nrDigits = 1;
	this.units = "m" //alternatively "m" for meters or String.fromCharCode(176) for deg sign
	//create background-element to receive events for showing coordinates
	var myBackgroundRect = document.createElementNS(svgNS,"rect");
	myBackgroundRect.setAttributeNS(null,"x",this.curxOrig);
	myBackgroundRect.setAttributeNS(null,"y",this.curyOrig);
	myBackgroundRect.setAttributeNS(null,"width",this.curWidth);
	myBackgroundRect.setAttributeNS(null,"height",this.curHeight);
	myBackgroundRect.setAttributeNS(null,"fill","none");
	myBackgroundRect.setAttributeNS(null,"stroke","none");
	mapSVG.insertBefore(myBackgroundRect,mapSVG.firstChild);
}

map.prototype.newViewBox = function(refRectId) {
	var myRefRect = document.getElementById(refRectId);
	this.curxOrig = parseFloat(myRefRect.getAttributeNS(null,"x"));
	this.curyOrig = parseFloat(myRefRect.getAttributeNS(null,"y"));
	this.curWidth = parseFloat(myRefRect.getAttributeNS(null,"width"));
	this.curHeight = parseFloat(myRefRect.getAttributeNS(null,"height"));
	var myViewBoxString = this.curxOrig + " " + this.curyOrig + " " + this.curWidth + " " + this.curHeight;
	this.pixSize = this.curWidth / this.pixWidth;
	this.zoomVal = this.origWidth / this.curWidth * 100;
	document.getElementById(this.mapName).setAttributeNS(null,"viewBox",myViewBoxString);
	myZoomSlider.setValue(this.curWidth);
	//loadProjectSpecific();
}

map.prototype.calcCoord = function(coordx,coordy) {
	var coords = myMapApp.calcCoord(coordx,coordy);
	var mapCoords = new Array();
	mapCoords["x"] = this.curxOrig + (coords["x"] - this.pixXOffset) * this.pixSize;
	mapCoords["y"] = (this.curyOrig + (coords["y"] - this.pixYOffset) * this.pixSize);
	return mapCoords;
}

map.prototype.zoomManual = function() {
	if (Math.round(myMainMap.zoomVal) < myMainMap.maxZoom) {
		var zoomBgRect = document.createElementNS(svgNS,"rect");
		zoomBgRect.setAttributeNS(null,"x",this.curxOrig);
		zoomBgRect.setAttributeNS(null,"y",this.curyOrig);
		zoomBgRect.setAttributeNS(null,"width",this.curWidth);
		zoomBgRect.setAttributeNS(null,"height",this.curHeight);
		zoomBgRect.setAttributeNS(null,"fill","white");
		zoomBgRect.setAttributeNS(null,"fill-opacity","0.3");
		zoomBgRect.setAttributeNS(null,"stroke","none");
		zoomBgRect.setAttributeNS(null,"id","zoomBgRectManual");
		zoomBgRect.addEventListener("mousedown",this, false);
		zoomBgRect.addEventListener("mousemove",this, false);
		zoomBgRect.addEventListener("mouseup",this, false);
		document.getElementById(this.mapName).appendChild(zoomBgRect);
		statusChange("Klicke in die Hauptkarte und ziehe ein Rechteck auf, um die Ansicht zu vergroessern.");
	}
}

map.prototype.handleEvent = function(evt) {
	var callerId = evt.target.getAttributeNS(null,"id");
	if (callerId.match(/\bzoomBgRectManual/)) {
		this.zoomManDragRect(evt);
	}
	if (callerId.match(/\bzoomBgRectRecenter/)) {
		this.recenterFinally(evt);
	}
}

map.prototype.zoomManDragRect = function(evt) {
	var mapCoords = this.calcCoord(evt.clientX,evt.clientY);
	var myX = mapCoords["x"];
	var myY = mapCoords["y"];
	var myMinWidth = this.origWidth / (this.maxZoom / 100);
	var myYXFact = this.curHeight / this.curWidth;
	if (evt.type == "mousedown") {
		this.manZoomActive = 1;
		this.zoomRect = document.createElementNS(svgNS,"rect");
		var myLineWidth = this.curWidth * 0.003;
		this.zoomRect.setAttributeNS(null,"id","zoomRect");
		this.zoomRect.setAttributeNS(null,"style","fill:rgb(255,255,153);fill-opacity:0.4;stroke:rgb(102,102,102);stroke-width:"+myLineWidth+";stroke-dasharray:"+(myLineWidth*3)+","+myLineWidth);
		this.zoomRect.setAttributeNS(null,"pointer-events","none");
		this.zoomRect.setAttributeNS(null,"x",myX);
		this.zoomRect.setAttributeNS(null,"y",myY);
		this.zoomRect.setAttributeNS(null,"width",myMinWidth);
		this.zoomRect.setAttributeNS(null,"height",myMinWidth * myYXFact);
		document.getElementById(this.mapName).appendChild(this.zoomRect);
	}
	if (evt.type == "mousemove" && this.manZoomActive == 1) {
		var myZoomWidth = myX - parseFloat(this.zoomRect.getAttributeNS(null,"x"));
		if (myZoomWidth < myMinWidth) {
			this.zoomRect.setAttributeNS(null,"width",myMinWidth);
			this.zoomRect.setAttributeNS(null,"height",myMinWidth * myYXFact);		
		}
		else {
			this.zoomRect.setAttributeNS(null,"width",myZoomWidth);
			this.zoomRect.setAttributeNS(null,"height",myZoomWidth * myYXFact);
		}
	}
	if (evt.type == "mouseup") {
		this.manZoomActive = 0;
		if (parseFloat(this.zoomRect.getAttributeNS(null,"width")) > this.curWidth * 0.02) {
			myRefMapDragger.newView(parseFloat(this.zoomRect.getAttributeNS(null,"x")),parseFloat(this.zoomRect.getAttributeNS(null,"y")),parseFloat(this.zoomRect.getAttributeNS(null,"width")),parseFloat(this.zoomRect.getAttributeNS(null,"height")));
			this.newViewBox(myRefMapDragger.dragId);
		}
		document.getElementById(this.mapName).removeChild(this.zoomRect);
		document.getElementById(this.mapName).removeChild(document.getElementById("zoomBgRectManual"));
		statusChange("Karte ist fertig.");
	}
}

map.prototype.recenter = function() {
	var zoomBgRect = document.createElementNS(svgNS,"rect");
	zoomBgRect.setAttributeNS(null,"x",this.curxOrig);
	zoomBgRect.setAttributeNS(null,"y",this.curyOrig);
	zoomBgRect.setAttributeNS(null,"width",this.curWidth);
	zoomBgRect.setAttributeNS(null,"height",this.curHeight);
	zoomBgRect.setAttributeNS(null,"fill","white");
	zoomBgRect.setAttributeNS(null,"fill-opacity","0.3");
	zoomBgRect.setAttributeNS(null,"stroke","none");
	zoomBgRect.setAttributeNS(null,"id","zoomBgRectRecenter");
	zoomBgRect.addEventListener("click",this.recenterFinally, false);
	document.getElementById(this.mapName).appendChild(zoomBgRect);
	statusChange("Klicke in die Karte, um neues Kartenzentrum zu definieren.");
}

map.prototype.recenterFinally = function(evt) {
	if (evt.type == "click") {
		var mapCoords = this.calcCoord(evt.clientX,evt.clientY);
		var myX = mapCoords["x"];
		var myY = mapCoords["y"];
		var myNewX = myX - this.curWidth / 2;
		var myNewY = myY - this.curHeight / 2;
		
		//check if within constraints
		if (myNewX < myRefMapDragger.constrXmin) {
			myNewX = myRefMapDragger.constrXmin;
		}
		if (myNewY < myRefMapDragger.constrYmin) {
			myNewY = myRefMapDragger.constrYmin;
		}
		if ((myNewX + this.curWidth) > myRefMapDragger.constrXmax) {
			myNewX = myRefMapDragger.constrXmax - this.curWidth;
		}
		if ((myNewY + this.curHeight) > myRefMapDragger.constrYmax) {
			myNewY = myRefMapDragger.constrYmax - this.curHeight;
		}
		myRefMapDragger.newView(myNewX,myNewY,this.curWidth,this.curHeight);
		newViewBox(myRefMapDragger.dragId);
			
		document.getElementById(this.mapName).removeChild(document.getElementById("zoomBgRectRecenter"));
				
		statusChange("Karte ist fertig.");
	}
}

//holds data on window size
function mapApp() {
	//no real constructor function yet
}

//calculate ratio and offset values of app window
mapApp.prototype.resetFactors = function() {
	var svgroot = document.documentElement;
	if (!svgroot.getScreenCTM) {
		//case for ASV3 and Corel
		var viewBoxArray = svgroot.getAttributeNS(null,"viewBox").split(" ");
		var myRatio = viewBoxArray[2]/viewBoxArray[3];
		if ((window.innerWidth/window.innerHeight) > myRatio) { //case window is more wide than myRatio
			this.scaleFactor = viewBoxArray[3] / window.innerHeight;
		}
		else { //case window is more tall than myRatio
			this.scaleFactor = viewBoxArray[2] / window.innerWidth;
		}
		this.offsetX = (window.innerWidth - viewBoxArray[2] * 1 / this.scaleFactor) / 2;
		this.offsetY = (window.innerHeight - viewBoxArray[3] * 1 / this.scaleFactor) / 2;
	}
}

mapApp.prototype.calcCoord = function(coordx,coordy) {
	var svgroot = document.documentElement;
	var coords = new Array();
	if (!svgroot.getScreenCTM) {
		//case ASV3 a. Corel
		coords["x"] = (coordx  - this.offsetX) * this.scaleFactor;
		coords["y"] = (coordy - this.offsetY) * this.scaleFactor;
	}
	else {
		matrix=svgroot.getScreenCTM();
		coords["x"]= matrix.inverse().a*coordx+matrix.inverse().c*coordy+matrix.inverse().e;
		coords["y"]= matrix.inverse().b*coordx+matrix.inverse().d*coordy+matrix.inverse().f;
	}
	return coords;
}

//make an element draggable with constraints
function dragObj(dragId,referenceMap,myDragSymbol,dragSymbThreshold) {
	this.dragId = dragId;
	this.myDragger = document.getElementById(this.dragId);
	this.myRefMap = document.getElementById(referenceMap);
	this.myDragSymbol = document.getElementById(myDragSymbol);	
	this.dragSymbThreshold = dragSymbThreshold;
	var viewBox = this.myRefMap.getAttributeNS(null,"viewBox").split(" ");
	this.constrXmin = parseFloat(viewBox[0]);
	this.constrYmin = parseFloat(viewBox[1]);
	this.constrXmax = this.constrXmin + parseFloat(viewBox[2]);
	this.constrYmax = this.constrYmin + parseFloat(viewBox[3]);
	this.refMapX = parseFloat(this.myRefMap.getAttributeNS(null,"x"));
	this.refMapY = parseFloat(this.myRefMap.getAttributeNS(null,"y"));
	this.refMapWidth = parseFloat(this.myRefMap.getAttributeNS(null,"width"));
	this.pixSize = (this.constrXmax - this.constrXmin) / this.refMapWidth;
	this.status = "false";
}

dragObj.prototype.calcCoord = function(coordx,coordy) {
	var coords = myMapApp.calcCoord(coordx,coordy);
	var mapCoords = new Array();
	mapCoords["x"] = this.constrXmin + (coords["x"] - this.refMapX) * this.pixSize;
	mapCoords["y"] = this.constrYmin + ((coords["y"]) - this.refMapY) * this.pixSize;
	return mapCoords;
}

dragObj.prototype.newView = function(x,y,width,height) {
	this.myDragger.setAttributeNS(null,"x",x);
	this.myDragger.setAttributeNS(null,"y",y);
	this.myDragger.setAttributeNS(null,"width",width);
	this.myDragger.setAttributeNS(null,"height",height);
	this.myDragSymbol.setAttributeNS(null,"x",(x + width/2));
	this.myDragSymbol.setAttributeNS(null,"y",(y + height/2));
	if (width < this.dragSymbThreshold) {
		this.myDragSymbol.setAttributeNS(null,"visibility","visible");
	}
	else {
		this.myDragSymbol.setAttributeNS(null,"visibility","hidden");	
	}
}

dragObj.prototype.resizeDragger = function(status,sliderGroupName,width) {
	var myX = parseFloat(this.myDragger.getAttributeNS(null,"x"));
	var myY = parseFloat(this.myDragger.getAttributeNS(null,"y"));
	var myWidth = parseFloat(this.myDragger.getAttributeNS(null,"width"));
	var myHeight = parseFloat(this.myDragger.getAttributeNS(null,"height"));
	var myCenterX = myX + myWidth / 2;
	var myCenterY = myY + myHeight / 2;
	var myRatio = myHeight / myWidth;
	var toMoveX = myCenterX - width / 2;
	var toMoveY = myCenterY - width * myRatio / 2;
	if (toMoveX < this.constrXmin) {
		toMoveX = this.constrXmin;
	}
	if ((toMoveX + width) > this.constrXmax) {
		toMoveX = this.constrXmax - width;
	}
	if (toMoveY < this.constrYmin) {
		toMoveY = this.constrYmin;
	}
	if ((toMoveY + width * myRatio) > this.constrYmax) {
		toMoveY = this.constrYmax - width * myRatio;
	}
	this.newView(toMoveX,toMoveY,width,width * myRatio);
	if (status == "release") {
		myMainMap.newViewBox(this.dragId);
	}
}

dragObj.prototype.drag = function(evt) {
	if (evt.type == "mousedown") {
		this.status = "true";
	}
	if ((evt.type == "mousemove" || evt.type == "mousedown") && this.status == "true") {
		var coords = this.calcCoord(evt.clientX,evt.clientY);
		var newEvtX = coords["x"];
		var newEvtY = coords["y"];
		var myX = parseFloat(this.myDragger.getAttributeNS(null,"x"));
		var myY = parseFloat(this.myDragger.getAttributeNS(null,"y"));
		var myWidth = parseFloat(this.myDragger.getAttributeNS(null,"width"));
		var myHeight = parseFloat(this.myDragger.getAttributeNS(null,"height"));
		var toMoveX = newEvtX - myWidth / 2;
		var toMoveY = newEvtY - myHeight / 2;
		if (toMoveX < this.constrXmin) {
			toMoveX = this.constrXmin;
		}
		if ((toMoveX + myWidth) > this.constrXmax) {
			toMoveX = this.constrXmax - myWidth;
		}
		if (toMoveY < this.constrYmin) {
			toMoveY = this.constrYmin;
		}
		if ((toMoveY + myHeight) > this.constrYmax) {
			toMoveY = this.constrYmax - myHeight;
		}
		this.newView(toMoveX,toMoveY,myWidth,myHeight);
	}
	if (evt.type == "mouseup" || evt.type == "mouseout") {
		this.status = "false";
	}
}

dragObj.prototype.zoom = function(inOrOut) {
	var myOldX = this.myDragger.getAttributeNS(null,"x");
	var myOldY = this.myDragger.getAttributeNS(null,"y");
	var myOldWidth = this.myDragger.getAttributeNS(null,"width");
	var myOldHeight = this.myDragger.getAttributeNS(null,"height");
	switch (inOrOut) {
		case "in":
			var myMinWidth = myMainMap.origWidth / (myMainMap.maxZoom / 100);
			var myNewX = parseFloat(myOldX) + myOldWidth / 2 - (myOldWidth * myMainMap.zoomFact * 0.5);
			var myNewY = parseFloat(myOldY) + myOldHeight / 2 - (myOldHeight * myMainMap.zoomFact * 0.5);
			var myNewWidth = myOldWidth * myMainMap.zoomFact;
			var myNewHeight = myOldHeight * myMainMap.zoomFact;
			if (myNewWidth < myMinWidth) {
				var myYXFact = myMainMap.curHeight / myMainMap.curWidth;
				myNewWidth = myMinWidth;
				myNewHeight = myNewWidth * myYXFact;
				myNewX = parseFloat(myOldX) + myOldWidth / 2 - (myNewWidth * 0.5);
				myNewY = parseFloat(myOldY) + myOldHeight / 2 - (myNewHeight * 0.5);
			}
			break;
		case "out":
			var myNewX = parseFloat(myOldX) + myOldWidth / 2 - (myOldWidth * (1 + myMainMap.zoomFact) * 0.5);
			var myNewY = parseFloat(myOldY) + myOldHeight / 2 - (myOldHeight * (1 + myMainMap.zoomFact) * 0.5);
			var myNewWidth = myOldWidth * (1 + myMainMap.zoomFact);
			var myNewHeight = myOldHeight * (1 + myMainMap.zoomFact);
			break;
		default:
			var myNewX = this.constrXmin;
			var myNewY = this.constrYmin;
			var myNewWidth = this.constrXmax - this.constrXmin;
			var myNewHeight = this.constrYmax - this.constrYmin;
			break;
	}	
	//check if within constraints
	if (myNewWidth > (this.constrXmax - this.constrXmin)) {
		myNewWidth = this.constrXmax - this.constrXmin;
	}
	if (myNewHeight > (this.constrYmax - this.constrYmin)) {
		myNewHeight = this.constrYmax - this.constrYmin;
	}
	if (myNewX < this.constrXmin) {
		myNewX = this.constrXmin;
	}
	if (myNewY < this.constrYmin) {
		myNewY = this.constrYmin;
	}
	if ((myNewX + myNewWidth) > this.constrXmax) {
		myNewX = this.constrXmax - myNewWidth;
	}
	if ((myNewY + myNewHeight) > this.constrYmax) {
		myNewY = this.constrYmax - myNewHeight;
	}
	//alert(myNewX+", "+myNewY+", "+myNewWidth+", "+myNewHeight);
	this.newView(myNewX,myNewY,myNewWidth,myNewHeight);
	myMainMap.newViewBox(this.dragId);
}

dragObj.prototype.pan = function (myX,myY,howmuch) {
	//get values from draggable rectangle
	var xulcorner = parseFloat(this.myDragger.getAttributeNS(null,"x"));
	var yulcorner = parseFloat(this.myDragger.getAttributeNS(null,"y"));
	var width = parseFloat(this.myDragger.getAttributeNS(null,"width"));
	var height = parseFloat(this.myDragger.getAttributeNS(null,"height"));

	//set values of draggable rectangle
	var rectXulcorner = xulcorner + howmuch * width * myX;
	var rectYulcorner = yulcorner + howmuch * height * myY;
	//check if within constraints
	if (rectXulcorner < this.constrXmin) {
		rectXulcorner = this.constrXmin;
	}
	if (rectYulcorner < this.constrYmin) {
		rectYulcorner = this.constrYmin;
	}
	if ((rectXulcorner + width) > this.constrXmax) {
		rectXulcorner = this.constrXmax - width;
	}
	if ((rectYulcorner + height) > this.constrYmax) {
		rectYulcorner = this.constrYmax - height;
	}
	this.newView(rectXulcorner,rectYulcorner,width,height);

	//set viewport of main map
	if ((xulcorner != rectXulcorner) || (yulcorner != rectYulcorner)) {
		myMainMap.newViewBox(this.dragId);
	}

	statusChange("Karte ist fertig.");
}

//magnifier glass mouse-over effects
function magnify(evt,scaleFact,inOrOut) {
	if (inOrOut == "in") {
		if (Math.round(myMainMap.zoomVal) < myMainMap.maxZoom) {
			statusChange("Kartenansicht vergroessern!");
			scaleObject(evt,scaleFact);
		}
		else {
			statusChange("Maximaler Zoomfaktor ist erreicht!");
		}
	}
	if (inOrOut == "out") {
		if (Math.round(myMainMap.zoomVal) > myMainMap.minZoom) {
			statusChange("Kartenansicht verkleinern!");
			scaleObject(evt,scaleFact);
		}
		else {
			statusChange("Minimaler Zoomfaktor ist erreicht!");
		}
	}
	if (inOrOut == "manual") {
		if (Math.round(myMainMap.zoomVal) < myMainMap.maxZoom) {
			statusChange("Klicke in die Hauptkarte und ziehe ein Rechteck auf.");
			scaleObject(evt,scaleFact);
		}
		else {
			statusChange("Maximaler Zoomfaktor ist erreicht!");
		}
	}
	if (inOrOut == "full") {
		if (Math.round(myMainMap.zoomVal) > myMainMap.minZoom) {
			statusChange("Gesamte Ansicht zeigen!");
			scaleObject(evt,scaleFact);
		}
		else {
			statusChange("Gesamte Ansicht erreicht!");
		}
	}
	if (scaleFact == 1) {
		statusChange("Karte ist fertig.");
		scaleObject(evt,scaleFact);
	}
}

function zoomIt(inOrOut) {
	if (inOrOut == "in") {
		if (Math.round(myMainMap.zoomVal) < myMainMap.maxZoom) {
			myRefMapDragger.zoom("in");
		}
		else {
			statusChange("Maximaler Zoomfaktor ist erreicht!");
		}
	}
	if (inOrOut == "out") {
		if (Math.round(myMainMap.zoomVal) > myMainMap.minZoom) {
			myRefMapDragger.zoom("out");
		}
		else {
			statusChange("Minimaler Zoomfaktor ist erreicht!");
		}
	}
	if (inOrOut == "full") {
		if (Math.round(myMainMap.zoomVal) > myMainMap.minZoom) {
			myRefMapDragger.zoom("full");
		}
		else {
			statusChange("Gesamte Ansicht erreicht!");
		}
	}
}

function panOver(evt) {
	var myRect = evt.target;
	if (evt.type == "mouseover") {
		myRect.setAttributeNS(null,"fill","lightgray");
	}
	if (evt.type == "mouseout") {
		myRect.setAttributeNS(null,"fill","white");
	}
}

//alert map extent
function showExtent() {
	with(myMainMap) {
		alert("Xmin="+curxOrig.toFixed(nrDigits)+units+"; Xmax="+(curxOrig + curWidth).toFixed(nrDigits)+units+"\nYmin="+((curyOrig + curHeight) * -1).toFixed(nrDigits) +units+"; Ymax="+(curyOrig*-1).toFixed(nrDigits)+units+"\nWidth="+curWidth.toFixed(nrDigits)+units+"; Height="+curHeight.toFixed(nrDigits)+units);
	}
}