//slider properties
function slider(x1,y1,value1,x2,y2,value2,startVal,sliderGroup,sliderColor,visSliderWidth,invisSliderWidth,sliderSymb,functionToCall,mouseMoveBool) {
	this.x1 = x1;
	this.y1 = y1;
	this.value1 = value1;
	this.x2 = x2;
	this.y2 = y2;
	this.value2 = value2;
	this.startVal = startVal;
	this.value = startVal;
	this.sliderGroup = sliderGroup;
	this.sliderColor = sliderColor;
	this.visSliderWidth = visSliderWidth;
	this.invisSliderWidth = invisSliderWidth;
	this.sliderSymb = sliderSymb;
	this.functionToCall = functionToCall;
	this.mouseMoveBool = mouseMoveBool;
	this.length = toPolarDist((this.x2 - this.x1),(this.y2 - this.y1));
	this.direction = toPolarDir((this.x2 - this.x1),(this.y2 - this.y1));
	this.createSlider();
	this.slideStatus = 0;
}

//create slider
slider.prototype.createSlider = function() {
	var mySliderLine = document.createElementNS(svgNS,"line");
	mySliderLine.setAttributeNS(null,"x1",this.x1);
	mySliderLine.setAttributeNS(null,"y1",this.y1);
	mySliderLine.setAttributeNS(null,"x2",this.x2);
	mySliderLine.setAttributeNS(null,"y2",this.y2);
	mySliderLine.setAttributeNS(null,"stroke",this.sliderColor);
	mySliderLine.setAttributeNS(null,"stroke-width",this.invisSliderWidth);
	mySliderLine.setAttributeNS(null,"opacity","0");
	mySliderLine.setAttributeNS(null,"id",this.sliderGroup+"_invisibleSliderLine");
	mySliderLine.addEventListener("mousedown",this,false);
	mySliderLine.addEventListener("mousemove",this,false);
	mySliderLine.addEventListener("mouseup",this,false);
	mySliderLine.addEventListener("mouseout",this,false);
	document.getElementById(this.sliderGroup).appendChild(mySliderLine);
	mySliderLine = document.createElementNS(svgNS,"line");
	mySliderLine.setAttributeNS(null,"x1",this.x1);
	mySliderLine.setAttributeNS(null,"y1",this.y1);
	mySliderLine.setAttributeNS(null,"x2",this.x2);
	mySliderLine.setAttributeNS(null,"y2",this.y2);
	mySliderLine.setAttributeNS(null,"stroke",this.sliderColor);
	mySliderLine.setAttributeNS(null,"stroke-width",this.visSliderWidth);
	mySliderLine.setAttributeNS(null,"id",this.sliderGroup+"_visibleSliderLine");
	mySliderLine.setAttributeNS(null,"pointer-events","none");
	document.getElementById(this.sliderGroup).appendChild(mySliderLine);
	mySliderSymb = document.createElementNS(svgNS,"use");
	mySliderSymb.setAttributeNS(xlinkNS,"xlink:href","#"+this.sliderSymb);
	var myStartDistance = this.length - ((this.value2 - this.startVal) / (this.value2 - this.value1)) * this.length;
	var myPosX = this.x1 + toRectX(this.direction,myStartDistance);
	var myPosY = this.y1 + toRectY(this.direction,myStartDistance);
	var myTransformString = "translate("+myPosX+","+myPosY+") rotate(" + Math.round(this.direction / Math.PI * 180) + ")";
	mySliderSymb.setAttributeNS(null,"transform",myTransformString);
	mySliderSymb.setAttributeNS(null,"id",this.sliderGroup+"_sliderSymbol");
	document.getElementById(this.sliderGroup).appendChild(mySliderSymb);
}

//handle events
slider.prototype.handleEvent = function(evt) {
	this.drag(evt);
}

//drag slider
slider.prototype.drag = function(evt) {
	var myCoords = myMapApp.calcCoord(evt.clientX,evt.clientY);
	var myDistance = toPolarDist((myCoords["x"] - this.x1),(myCoords["y"] - this.y1));
	var myPercentage = myDistance / this.length;
	this.value = this.value1 + myPercentage * (this.value2 - this.value1);
	if (myPercentage < 0.05) {
		var myLength = toPolarDist((myCoords["x"] - this.x2),(myCoords["y"] - this.y2));
		if (myLength > this.length) {
			this.value = this.value1;
		}
	}
	if (this.value > this.value2) {
		this.value = this.value2;
	}
	if (evt.type == "mousedown" || (evt.type == "mousemove" && this.slideStatus == 1)) {
		if (evt.type == "mousedown") {
			this.slideStatus = 1;
		}
		var myPosX = this.x1 + toRectX(this.direction,myDistance);
		var myPosY = this.y1 + toRectY(this.direction,myDistance);
		var myTransformString = "translate("+myPosX+","+myPosY+") rotate(" + Math.round(this.direction / Math.PI * 180) + ")";
		document.getElementById(this.sliderGroup+"_sliderSymbol").setAttributeNS(null,"transform",myTransformString);
		this.getValue();
	}
	if (evt.type == "mouseup" || evt.type == "mouseout") {
		if (this.slideStatus == 1) {
			this.slideStatus = 2;
			this.getValue();
		}
		this.slideStatus = 0;
	}
}

//this code is executed, after the slider is released
//you can use switch/if to detect which slider was used (use this.sliderGroup) for that
slider.prototype.getValue = function() {
	if (this.slideStatus == 1 && this.mouseMoveBool == true) {
		eval(this.functionToCall+"('change','"+this.sliderGroup+"',"+this.value+")");
	}
	if (this.slideStatus == 2) {
		eval(this.functionToCall+"('release','"+this.sliderGroup+"',"+this.value+")");
	}
}	

//this is to set the value from other scripts
slider.prototype.setValue = function(value) {
	var myPercAlLine = (value - this.value1) / (this.value2 - this.value1);
	this.value = myPercAlLine;
	var myPosX = this.x1 + toRectX(this.direction,this.length * myPercAlLine);
	var myPosY = this.y1 + toRectY(this.direction,this.length * myPercAlLine);
	var myTransformString = "translate("+myPosX+","+myPosY+") rotate(" + Math.round(this.direction / Math.PI * 180) + ")";
	document.getElementById(this.sliderGroup+"_sliderSymbol").setAttributeNS(null,"transform",myTransformString);
}	